//+------------------------------------------------------------------+
//|                                                  FFT_Lanczos.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+


#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//#property indicator_chart_window
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
#property indicator_height 400
//--- plot FFT
#property indicator_label1  "FFT"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2
#include <Object.mqh>
#include <Charts\Chart.mqh>
      double shift_size;
      double Miofixed_max;
      double Miofixed_min;
      double Miopoints_per_bar;
      long   Miomode;
      bool   Mioforeground;
      bool   Mioshift;
      bool   autoscroll;
      long   scale;
      bool   scalefix;
      bool   scalefix_11;
      bool   scale_pt_per_bar;
      bool   show_ohls;
      bool   show_bid_line;
      bool   show_ask_line;
      bool   show_last_line;
      bool   show_period_sep;
      bool   show_grid;
      long   show_volumes;
      bool   show_object_descr;
      bool   show_trade_levels;
      long  color_background;
      long  color_foreground;
      long  color_grid;
      long  color_volume;
      long  color_chart_up;
      long  color_chart_down;
      long  color_chart_line;
      long  color_candle_bull;
      long  color_candle_bear;
      long  color_bid;
      long  color_ask;
      long  color_last;
      long  color_stop_level;
      string ch_comment;
      //long distSottoFinestra;
      


//--- indicator buffers
double         FFTBuffer[];
double Uno[],Due[];


CChart Miochart;

double AmpCos[],AmpSin[],Amp[];
bool firstLoop=true;


color sfondo = clrWhite;

void OnDeinit(const int reason)
  {
         Restore_Chart();
         
  }


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,FFTBuffer,INDICATOR_DATA);
   PlotIndexSetString(0,PLOT_LABEL,"Spectrum");           // Init ndicator buffer


  /* chart.VScaleParams(10,0,1);    //Sets parameters for vertical scale
   chart.ShowScaleTop(false);          // Sets visibility flag for top scale  
   chart.ShowScaleRight(false);        //Sets visibility flag for right scale 
   chart.ShowLegend();
   ChProp.autoscroll
   */
   //chart.Filled();                   //adjusted parameters
   

  Backup_Chart();
  Init_Chart();

   firstLoop=true;
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
  
   int bars=Bars(Symbol(),0); 

     
   
     
  if(IsNewBar()==true || firstLoop==true) 
  {   
     

   /*    if(!chart.CreateBitmapLabel("Canvas",10,10,CanvasSize,450))
     {
      Print("Error creating line chart: ",GetLastError());
      return(-1);
     }
 */
   //int Datas=400;
   //ArrayResize(Amp,Datas);
 
   //for(int i=0;i<Datas;i++) Amp[i]=MathMod(i,10);
   for(int i=0;i<rates_total;i++) FFTBuffer[i]=MathMod(i,5);
   
   //chart.SeriesAdd(Amp,"Ampiezza composita"); 
   
   firstLoop=false;
  }
   
   
   
   

   


   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+


bool IsNewBar() 
 {
//--- memorize the time of opening of the last bar in the static variable
   static long   last_time=0;
//--- current time
   long   lastbar_time=SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE);
//--- if it is the first call of the function
   if(last_time==0)
     {
      //--- set the time and exit
      last_time=lastbar_time;
      return(false);
     }
//--- if the time differs
   if(last_time!=lastbar_time)
     {
      //--- memorize the time and return true
      last_time=lastbar_time;
      return(true);
     }
//--- if we passed to this line, then the bar is not new; return false
   return(false);
 }
 
 

CChart  MainChart; 
  
  

  
  //------------------------------------------ Writing chart propertyes to file --
void Backup_Chart(void)
  {
  shift_size=ChartGetDouble(0,CHART_SHIFT_SIZE);
  Miofixed_max=ChartGetDouble(0,CHART_FIXED_MAX);
  Miofixed_min=ChartGetDouble(0,CHART_FIXED_MIN);
  Miopoints_per_bar=ChartGetDouble(0,CHART_POINTS_PER_BAR);
  Miomode=ChartGetInteger(0,CHART_MODE);
  Mioforeground=ChartGetInteger(0,CHART_FOREGROUND);
  Mioshift=ChartGetInteger(0,CHART_SHIFT);
  autoscroll=ChartGetInteger(0,CHART_AUTOSCROLL);
  scale=ChartGetInteger(0,CHART_SCALE);
  scalefix=ChartGetInteger(0,CHART_SCALEFIX);
  scalefix_11=ChartGetInteger(0,CHART_SCALEFIX_11);
  scale_pt_per_bar=ChartGetInteger(0,CHART_SCALE_PT_PER_BAR);
  show_ohls=ChartGetInteger(0,CHART_SHOW_OHLC);
  show_bid_line=ChartGetInteger(0,CHART_SHOW_BID_LINE);
  show_ask_line=ChartGetInteger(0,CHART_SHOW_ASK_LINE);
  show_last_line=ChartGetInteger(0,CHART_SHOW_LAST_LINE);
  show_period_sep=ChartGetInteger(0,CHART_SHOW_PERIOD_SEP);
  show_grid=ChartGetInteger(0,CHART_SHOW_GRID);
  show_volumes=ChartGetInteger(0,CHART_SHOW_VOLUMES);
  show_object_descr=ChartGetInteger(0,CHART_SHOW_OBJECT_DESCR);
  show_trade_levels=ChartGetInteger(0,CHART_SHOW_TRADE_LEVELS);  
  color_background=ChartGetInteger(0,CHART_COLOR_BACKGROUND);
  color_foreground=ChartGetInteger(0,CHART_COLOR_FOREGROUND);
  color_grid=ChartGetInteger(0,CHART_COLOR_GRID);
  color_volume=ChartGetInteger(0,CHART_COLOR_VOLUME);
  color_chart_up=ChartGetInteger(0,CHART_COLOR_CHART_UP);
  color_chart_down=ChartGetInteger(0,CHART_COLOR_CHART_DOWN);
  color_chart_line=ChartGetInteger(0,CHART_COLOR_CHART_LINE);
  color_candle_bull=ChartGetInteger(0,CHART_COLOR_CANDLE_BULL);
  color_candle_bear=ChartGetInteger(0,CHART_COLOR_CANDLE_BEAR);
  color_bid=ChartGetInteger(0,CHART_COLOR_BID);
  color_ask=ChartGetInteger(0,CHART_COLOR_ASK);
  color_last=ChartGetInteger(0,CHART_COLOR_LAST);
  color_stop_level=ChartGetInteger(0,CHART_COLOR_STOP_LEVEL);
  ch_comment=ChartGetString(0,CHART_COMMENT);
  //distSottoFinestra=ChartGetInteger(0,CHART_WINDOW_YDISTANCE);
  
  }
//------------------------------------ Restoring chart propertyes from memory --
void Restore_Chart(void)
  {
  ChartSetDouble(0,CHART_SHIFT_SIZE,shift_size);
  ChartSetDouble(0,CHART_FIXED_MAX,Miofixed_max);
  ChartSetDouble(0,CHART_FIXED_MIN,Miofixed_min);
  ChartSetDouble(0,CHART_POINTS_PER_BAR,Miopoints_per_bar);
  ChartSetInteger(0,CHART_MODE,Miomode);
  ChartSetInteger(0,CHART_FOREGROUND,Mioforeground);
  ChartSetInteger(0,CHART_SHIFT,Mioshift);
  ChartSetInteger(0,CHART_AUTOSCROLL,autoscroll);
  ChartSetInteger(0,CHART_SCALE,scale);
  ChartSetInteger(0,CHART_SCALEFIX,scalefix);
  ChartSetInteger(0,CHART_SCALEFIX_11,scalefix_11);
  ChartSetInteger(0,CHART_SCALE_PT_PER_BAR,scale_pt_per_bar);
  ChartSetInteger(0,CHART_SHOW_OHLC,show_ohls);
  ChartSetInteger(0,CHART_SHOW_BID_LINE,show_bid_line);
  ChartSetInteger(0,CHART_SHOW_ASK_LINE,show_ask_line);
  ChartSetInteger(0,CHART_SHOW_LAST_LINE,show_last_line);
  ChartSetInteger(0,CHART_SHOW_PERIOD_SEP,show_period_sep);
  ChartSetInteger(0,CHART_SHOW_GRID,show_grid);
  ChartSetInteger(0,CHART_SHOW_VOLUMES,show_volumes);
  ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,show_object_descr);
  ChartSetInteger(0,CHART_SHOW_TRADE_LEVELS,show_trade_levels);  
  ChartSetInteger(0,CHART_COLOR_BACKGROUND,color_background);
  ChartSetInteger(0,CHART_COLOR_FOREGROUND,color_foreground);
  ChartSetInteger(0,CHART_COLOR_GRID,color_grid);
  ChartSetInteger(0,CHART_COLOR_VOLUME,color_volume);
  ChartSetInteger(0,CHART_COLOR_CHART_UP,color_chart_up);
  ChartSetInteger(0,CHART_COLOR_CHART_DOWN,color_chart_down);
  ChartSetInteger(0,CHART_COLOR_CHART_LINE,color_chart_line);
  ChartSetInteger(0,CHART_COLOR_CANDLE_BULL,color_candle_bull);
  ChartSetInteger(0,CHART_COLOR_CANDLE_BEAR,color_candle_bear);
  ChartSetInteger(0,CHART_COLOR_BID,color_bid);
  ChartSetInteger(0,CHART_COLOR_ASK,color_ask);
  ChartSetInteger(0,CHART_COLOR_LAST,color_last);
  ChartSetInteger(0,CHART_COLOR_STOP_LEVEL,color_stop_level);
  ChartSetString(0,CHART_COMMENT,ch_comment);
  //ChartSetInteger(0,CHART_WINDOW_YDISTANCE,distSottoFinestra);
  }
//--------------------------------------------------- Prepare screen for draw --
void Init_Chart(void)
  {
  ChartSetInteger(0,CHART_FOREGROUND,1);
  ChartSetInteger(0,CHART_SHIFT,0);
  ChartSetInteger(0,CHART_AUTOSCROLL,0);
  ChartSetInteger(0,CHART_AUTOSCROLL,1);
  ChartSetInteger(0,CHART_SCALE,0);
  ChartSetInteger(0,CHART_SCALEFIX_11,1);
  ChartSetInteger(0,CHART_SHOW_OHLC,0);
  ChartSetInteger(0,CHART_SHOW_BID_LINE,0);
  ChartSetInteger(0,CHART_SHOW_ASK_LINE,0);
  ChartSetInteger(0,CHART_SHOW_LAST_LINE,0);
  ChartSetInteger(0,CHART_SHOW_PERIOD_SEP,0);
  ChartSetInteger(0,CHART_SHOW_GRID,0);
  ChartSetInteger(0,CHART_SHOW_VOLUMES,CHART_VOLUME_HIDE);
  ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,0);
  ChartSetInteger(0,CHART_SHOW_TRADE_LEVELS,0);
  ChartSetInteger(0,CHART_COLOR_BACKGROUND,sfondo);
  ChartSetInteger(0,CHART_COLOR_FOREGROUND,sfondo);
  //ChartSetDouble(0,CHART_FIXED_MAX,0.0);
  ChartSetDouble(0,CHART_FIXED_MIN,0.0);
  //long altezza = ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS);
  //ChartSetInteger(0,CHART_WINDOW_YDISTANCE,altezza);  read only
  }





      
      
      
      
      
      
      

